var db={};
db.keySet=[];
db.set = function(key,value){
	db.keySet.push(key);
	if(typeof(value) != 'object'){
		window.localStorage.setItem(key,value);
	}else{
		window.localStorage.setItem(key,JSON.stringify(value));
	}
}
db.destroy = function(){
	for(var i=0;i<db.keySet.length;i++){
		db.clear(db.keySet[i]);
	}
	db.keySet=[];
}
db.clear=function(key){
	window.localStorage.removeItem(key);
}
db.get = function(key){
	
	var value = window.localStorage.getItem(key);
	try{
		return JSON.parse(value);
	}catch(e){
		return value;
	}
}
db.setItem=function(key,value1,value2){
	try{
		var obj = JSON.parse(window.localStorage.getItem(key));
		if(typeof(obj) == 'object'){
			if(obj.length || obj.length ==0){
				obj.push(value1);
			}else{
				obj[value1]=value2;
			}
			db.set(key,obj);
		}
		if(obj==null){
			if(value2){
				
				db.set(key,{value1:value2});
			}else{
				db.set(key,[value1]);
			}
		}
	}catch(e){
		return false;
	}
}
db.has=function(key,rule){
	try{
		var obj = JSON.parse(window.localStorage.getItem(key));
		if(typeof(obj) == 'object'){
			if(obj.length){
				var max= obj.length-1;
				for(var i=max;i>=0;i--){
					if(rule(obj[i])){
						return true;
					}
				}
			}else{
				return obj[rule];
			}
		}
	}catch(e){
		return false;
	}
}
db.clearItem=function(key,rule){
	try{
		var obj = JSON.parse(window.localStorage.getItem(key));
		if(typeof(obj) == 'object'){
			if(obj.length){
				var max= obj.length-1;
				for(var i=max;i>=0;i--){
					if(rule(obj[i])){
						obj.splice(i,1);
					}
				}
			}else{
				delete obj[rule];
			}
			db.set(key,obj);
		}
	}catch(e){
		return false;
	}
}

db.updateItem=function(key,rule){
	try{
		var obj = JSON.parse(window.localStorage.getItem(key));
		if(typeof(obj) == 'object'){
			if(obj.length){
				var max= obj.length-1;
				for(var i=max;i>=0;i--){
					obj[i] = rule(obj[i]);
				}
			}else{
				obj[i] = rule(obj[i]);
			}
			db.set(key,obj);
		}
	}catch(e){
		return false;
	}
}
if(!db.get("icon")){
	db.set("icon",'../images/user1.jpg');
}
/*
 window.localStorage use ex:
 * */
/*
db.set("listaaa",[{a:1,b:2},{a:1,b:3},{a:2,b:4}]);
db.setItem("listaaa",{a:3,b:2});
db.clearItem('listaaa',function(d){return d.a==1});
//db.get("listaaa") output:[{a:2,b:4},{a:3,b:2}]

db.set("listbbb",[1,2,3,4,5]);
db.setItem("listbbb",6);
db.clearItem('listbbb',function(d){return d==1});
//db.get("listbbb") output:[2,3,4,5,6]

db.set("mapbbb",{a:1,b:1,c:1});
db.setItem("mapbbb","d",1);
db.clearItem('mapbbb','a');
//db.get("mapbbb") output:{b:1,c:1,d:1}]
*/